/*
 * LinkManager Tyler 1998-2000.
 */

   public class LinkManager extends Object {
      Link[] entity_link;
      Link[] new_array_of_links;
   
      int max_number_of_links = 128;
      int number_of_links;
   
      // static stuff...
      static int agent_counter;
      static int shift = Entity.shift;
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static Link temp_link;
   
      static Entity temp_entity;
      static int threshold = 8;
      static int bigthreshold = threshold << Entity.shift;
   
      static int temp_x, temp_y, temp_radius;
   
      static int LINK_NUMBER_INCREMENT = 16;
   
   
      LinkManager() {
         entity_link = new Link[max_number_of_links];
      
         reset();
      }
   
   
      void reset() {
      		// makes no odds...
         // entity_link = new Link[max_number_of_links];
      
         //for (temp = number_of_links; --temp >= 0; ) {
            //if (entity_link[temp] != null) {
               // entity_link[temp] = null; // [temp].status |= Link.DEAD;
               // entity_link[temp].entity1 = null;
               // entity_link[temp].entity2 = null;
            //}
         //}
      
         number_of_links = 0;
      }
   
   
   /*
      final public void initial() {
         entity_link = new Link[max_number_of_links];
         number_of_links = 0;
      }
   	*/
   
   /*
      // maximum value check....
      final Link setLink(Entity e1, Entity e2, int l, int e) {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         if (entity_link[number_of_links] == null) {
            entity_link[number_of_links] = new Link(e1, e2, l, e);
         }
         else
         {
            entity_link[number_of_links].set(e1, e2, l, e);
         }
      
      	// add this link to the list of links associated with the entity...
         temp_link = entity_link[number_of_links++];
      
         e1.addLink(temp_link);
         e2.addLink(temp_link);
      
         return temp_link;
      }
   	*/
   
   
      final Link setLink(Entity e1, Entity e2, int l, int e, int c, int s) {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         if (entity_link[number_of_links] == null) {
            temp_link = new Link(e1, e2, l, e, c, s);
            entity_link[number_of_links++] = temp_link;
         }
         else
         {
            temp_link = entity_link[number_of_links++];
            temp_link.set(e1, e2, l, e, c, s);
         }
      
      	// add this link to the list of links associated with the entity...
         // temp_link = entity_link[number_of_links++];
      
         e1.addLink(temp_link);
         e2.addLink(temp_link);
      
         return temp_link;
      }
   
   
      final Link setLink(Entity e1, Entity e2, Link l) {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         if (entity_link[number_of_links] == null) {
            temp_link = new Link(e1, e2, l.lower_length_limit, l.elasticity, l.colour, l.status);
            entity_link[number_of_links++] = temp_link;
         }
         else
         {
            temp_link = entity_link[number_of_links++];
            temp_link.set(e1, e2, l.lower_length_limit, l.elasticity, l.colour, l.status);
         }
      
      	// add this link to the list of links associated with the entity...
         // temp_link = entity_link[number_of_links++];
      
         e1.addLink(temp_link);
         e2.addLink(temp_link);
      
         return temp_link;
      }
   
   
   // DANGER
      final void setLink(Link l) {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         // entity_link[number_of_links++] = l; /// eeekkkk!
         entity_link[number_of_links++].set(l); /// eeekkkk!
      }
   
   
      // wotz this for??
      // maximum value check....
      final Link setLink() {
         if (number_of_links >= max_number_of_links) {
            makeMoreLinks();
         }
      
         // temp_entity = new Entity();
      
         if (entity_link[number_of_links] == null) {
            entity_link[number_of_links] = new Link(null, null, 0, 0);
         }
         else
         {
            entity_link[number_of_links].set(null,null, 0, 0);
         }
      
      	// add this link to the list of links associated with the entity...
         temp_link = entity_link[number_of_links++];
      
         return temp_link;
      }
   
   
      final void makeMoreLinks() {
         new_array_of_links = new Link[max_number_of_links + LINK_NUMBER_INCREMENT];
      
         for (temp = max_number_of_links; --temp >= 0; ) {
            new_array_of_links[temp] = entity_link[temp];
         }
      
         entity_link = new_array_of_links;
      
         max_number_of_links += LINK_NUMBER_INCREMENT;
      }
   
   
      final boolean aLinkLikeThisExists(Entity e1, Entity e2) {
         for (temp = number_of_links; --temp >= 0; ) {
            if ((entity_link[temp].entity1 == e1) && (entity_link[temp].entity2 == e2)) {
               return true;
            }
         
            if ((entity_link[temp].entity1 == e2) && (entity_link[temp].entity2 == e1)) {
               return true;
            }
         }
      
         return false;
      }
   
   
   // need to re-write this so that it uses local list of links stored with entity...

   // doesn't quite work properly...
      final void deleteAllLinksBetween(Entity e1, Entity e2) {
         for (temp = number_of_links; --temp >= 0; ) {
            if ((entity_link[temp].entity1 == e1) && (entity_link[temp].entity2 == e2)) {
               killNumberedLink(temp);
            }
         
            if ((entity_link[temp].entity1 == e2) && (entity_link[temp].entity2 == e1)) {
               killNumberedLink(temp);
            }
         }
      }
   
   
   // need to rewrite this so that it uses local list of links stored with entity...
      final boolean isThereALinkBetween(Entity e1, Entity e2) {
         Link temp_link;
      
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            // first one way...
            if ((temp_link.entity1 == e1) && (temp_link.entity2 == e2)) {
               return true;
            }
         
            // then the other...
            if ((temp_link.entity1 == e2) && (temp_link.entity2 == e1)) {
               return true;
            }
         }
      
         return false;
      }
   
   
   // need to rewrite this so that it uses local list of links stored with entity...
      final Link linkBetween(Entity e1, Entity e2) {
         Link temp_link;
      
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.entity1 == e1) && (temp_link.entity2 == e2)) {
               return entity_link[temp];
            }
         
            if ((temp_link.entity1 == e2) && (temp_link.entity2 == e1)) {
               return temp_link;
            }
         }
      
         return null;
      }
   
   	// need to rewrite this so that it uses local list of links stored with entity...
   
      final boolean isThereALinkFromTo(Entity e1, Entity e2) {
         Link temp_link;
      
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            // one way only...
            if ((temp_link.entity1 == e1) && (temp_link.entity2 == e2)) {
               return true;
            }
         
         }
      
         return false;
      }
   
   
   // need to rewrite this so that it uses local list of links stored with entity...
   
      final Link linkFromTo(Entity e1, Entity e2) {
         Link temp_link;
      
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.entity1 == e1) && (temp_link.entity2 == e2)) {
               return entity_link[temp];
            }
         
         }
      
         return null;
      }
   
   
      // hmm...
   
      final void killAllLinks(Entity e) {
         for (temp = number_of_links; --temp >= 0; ) {
            if ((entity_link[temp].entity1 == e) || (entity_link[temp].entity2 == e)) {
               killNumberedLink(temp);
            }
         }
      }
   
   
      // hmm...
      final boolean killLastLink(Entity e) {
         for (temp = number_of_links; --temp >= 0; ) {
            if ((entity_link[temp].entity1 == e) || (entity_link[temp].entity2 == e)) {
               killNumberedLink(temp);
               return true;
            }
         }
      
         return false;
      }
   
   
      final void killNumberedLink(int n) {
         temp_link = entity_link[n];
         if ((temp_link.status & Link.DEAD) == 0) {
            temp_link.scrub();
         
            // need to tell the entities involved...
            temp_link.entity1.list_of_links.remove(temp_link);
            temp_link.entity2.list_of_links.remove(temp_link);
         
            temp_link.entity1 = null;
            temp_link.entity2 = null;
            entity_link[n] = entity_link[number_of_links - 1];
            entity_link[--number_of_links] = temp_link;
         
            temp_link.status |= Link.DEAD; // you need to make sure you don't try to kill a creature twice...
         }
         else
         {
            debug("ATTEMPT TO KILL DEAD LINK!");
         }
      }
   
   
      final int getNumberOfLink(Link l) {
         for (temp = number_of_links; --temp >= 0; ) {
            if (entity_link[temp] == l) {
               return temp;
            } 
         }
      
         return -1; // not found...
      }
   
   
      final void killSpecifiedLink(Link l) {
         if ((l.status & Link.DEAD) == 0) {
            l.status |= Link.DEAD;
            l.scrub();
            temp = getNumberOfLink(l);
            killNumberedLink(temp);
         }
      }
   
   
      final void drawTheLinks() {
         for (agent_counter = number_of_links; --agent_counter >= 0; ) {
            entity_link[agent_counter].draw();
         }
      }
   
   
      final void exerciseTheLinks() {
         for (agent_counter = number_of_links; --agent_counter >= 0; ) {
            entity_link[agent_counter].applyForce();
         }
      }
   
   
      final void scrubTheLinks() {
         Shoals_Grid.colourZero();
         for (agent_counter = number_of_links; --agent_counter >= 0; ) {
            entity_link[agent_counter].scrub();
         }
      }
   
   
      final void linkUpdating() {
         for (agent_counter = number_of_links; --agent_counter >= 0; ) {   
            entity_link[agent_counter].scrub();
         
            if (!Shoals.paused) {
               entity_link[agent_counter].applyForce();
            }
         
            entity_link[agent_counter].draw();
         }
      }
   
   
      final public Link isThereOne(int x, int y) {
         for (temp2 = 0; temp2 < number_of_links; temp2++) {
            temp_link = entity_link[temp2];
            if ((temp_link.colour != 0) || (Link.link_display_type == Link.BLEACHED)) {
               if ((x >= (temp_link.entity1.x - bigthreshold)) && (x <= (temp_link.entity2.x + bigthreshold))) {
                  if ((y >= (temp_link.entity1.y - bigthreshold)) && (y <= (temp_link.entity2.y + bigthreshold))) {
                     if (distanceToLine(x,y,temp_link.entity1.x,temp_link.entity1.y,temp_link.entity2.x,temp_link.entity2.y) < threshold) {
                        return temp_link;
                     }
                  }
                  // else
                  // {
                  if ((y >= (temp_link.entity2.y - bigthreshold)) && (y <= (temp_link.entity1.y + bigthreshold))) {
                     if (distanceToLine(x,y,temp_link.entity1.x,temp_link.entity1.y,temp_link.entity2.x,temp_link.entity2.y) < threshold) {
                        return temp_link;
                     }
                  }
                  // }
               }
            }
            // else
            //{
            if ((x >= (temp_link.entity2.x - bigthreshold)) && (x <= (temp_link.entity1.x + bigthreshold))) {
               if ((y >= (temp_link.entity1.y - bigthreshold)) && (y <= (temp_link.entity2.y + bigthreshold))) {
                  if (distanceToLine(x,y,temp_link.entity1.x,temp_link.entity1.y,temp_link.entity2.x,temp_link.entity2.y) < threshold) {
                     return temp_link;
                  }
               }
                  // else
                  // {
               if ((y >= (temp_link.entity2.y - bigthreshold)) && (y <= (temp_link.entity1.y + bigthreshold))) {
                  if (distanceToLine(x,y,temp_link.entity1.x,temp_link.entity1.y,temp_link.entity2.x,temp_link.entity2.y) < threshold) {
                     return temp_link;
                  }
               }
                  //}
               //}
            }
         }
      
         return null;
      }
   
   
      // co_ords, line start, line end...
      final static int distanceToLine(int _x, int _y, int _x1, int _y1, int _x2, int _y2) {
         int dx1 = (_y1 - _y2) >> Entity.shift; // unit vector at right angles to line.
         int dy1 = (_x2 - _x1) >> Entity.shift;
      
         // int dx1 = (_x2 - _x1) >> Entity.shift; // unit vector at right angles to line.
         // int dy1 = (_y2 - _y1) >> Entity.shift;
      
        // debug ("dx1:" + dx1 + " dy1:" + dy1);
      
         int dist = SquareRoot.sqrt(1 + (dx1 * dx1) + (dy1 * dy1)); // pixels...
      
        // debug ("d:" + dist);
      
         dx1 = (dx1 << Entity.shift) / dist;
         dy1 = (dy1 << Entity.shift) / dist;
      
        // debug ("uv_x:" + dx1 + " uv_y:" + dy1);  // unit vector 0 - 255...
      
         int dx2 = (_x - _x1) >> Entity.shift;  // in pixels...
         int dy2 = (_y - _y1) >> Entity.shift;  // in pix...
      
        // debug ("dx2:" + dx2 + " dy2:" + dy2); // pix
      
         // int vector_x = (dx1 * dx2) >> Entity.shift;
         //int vector_y = (dy1 * dy2) >> Entity.shift;
      
         //debug ("vx:" + vector_x + " vy:" + vector_y);
      
         //temp = (int)(Math.sqrt(1 + (vector_x * vector_x) + (vector_y * vector_y)));
      
         //debug ("final:" + temp + "\n");
      
         dist = ((dx1 * dx2) + (dy1 * dy2)) >> Entity.shift;
      
         // debug("final:" + dist);
      
         return (dist < 0) ? -dist : dist;
      
        // debug ("final2:" + temp + "\n");
      
         // return temp;
      }
   
   
      final void deselectAll() {
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.status & Link.SELECTED) != 0) {
               temp_link.scrub();
               temp_link.status &= (-1 ^ Link.SELECTED);
            }
         }
      }
   
   
      final void deleteSelected() {
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.status & Link.SELECTED) != 0) {
               killSpecifiedLink(temp_link);
            }
         }
      }
   
   
      final void setColourOfSelected(int c) {
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.status & Link.SELECTED) != 0) {
               temp_link.colour = c;
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      final void setSizeOfSelected(int s) {
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.status & Link.SELECTED) != 0) {
               temp_link.setLength(s);
            }
         }
      }
   
   
      final void setElasticityOfSelected(int e) {
         for (temp = number_of_links; --temp >= 0; ) {
            temp_link = entity_link[temp];
            if ((temp_link.status & Link.SELECTED) != 0) {
               temp_link.setElasticity(e);
            }
         }
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
