/*
 * Particle Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class Particle extends Object {
      static int shift = 8;
   
      int x; // Image offScrImage;
      int y; // 
   
      int dx; //
      int dy; // 
   
      int count;
   
      static int friction_strength = 4;
   
      int temp_x;
      int temp_y;
   
      int type;
   
      static int temp;
   
      // static int diameter = 18;
      // static int radius = diameter >>> 1;
   
      static int size_x;
      static int size_y;
   
      final static int POINT = 0;
      final static int CROSS = 1;
      final static int BLOB = 2;
   
   
      final static int[] size_LUT_x = {
         0, 1, 1, 2, 2, 3, 3, 4};
   
      final static int[] size_LUT_y = {
         0, 0, 1, 1, 2, 2, 3, 3};
   
   
      //Particle() {
      //}
   
      Particle(int ix, int iy, int idx, int idy, int t) {
         x = ix;// - idx;
         y = iy;// - idy;
      
         dx = idx;
         dy = idy;
      
         count = (x + dx + dy) & 63;
         type = t;
      }
   
   
      // in internal co-ordinates....
      final public void set(int ix, int iy, int idx, int idy, int t) {
         x = ix;// - idx;
         y = iy;//; - idy;
      
         dx = idx;
         dy = idy;
      
         count = (x + dx + dy) & 63;
         type = t;
      }
   
   
      final public static void initial() {
      }
   
   
      public void draw() {
         switch (type) {
            case BLOB:
               Shoals_Grid.graphics_handle.fillRect(x >>> shift, y >>> shift, size_LUT_x[count >> 3], size_LUT_y[count >> 3]);
            
               break;
         
            case POINT:
               Shoals_Grid.graphics_handle.fillRect(x >>> shift, y >>> shift, 0, 0);
            
               break;
         
            case CROSS:
               size_x = size_LUT_x[count >> 3];
               size_y = size_LUT_y[count >> 3];
            
               Shoals_Grid.graphics_handle.drawLine((x >>> shift) - size_x, y >>> shift, (x >>> shift) + size_x, y >>> shift);
               Shoals_Grid.graphics_handle.drawLine(x >>> shift, (y >>> shift) - size_y, x >>> shift, (y >>> shift) + size_y);
            
               break;
         }
      }
   
   
      public void scrub() {
         switch (type) {
            case BLOB:
               Shoals_Grid.graphics_handle.fillRect(x >>> shift, y >>> shift, size_LUT_x[count >> 3], size_LUT_y[count >> 3]);
            
               break;
         
            case POINT:
               Shoals_Grid.graphics_handle.fillRect(x >>> shift, y >>> shift, 0, 0);
            
               break;
         
            case CROSS:
               size_x = size_LUT_x[count >> 3];
               size_y = size_LUT_y[count >> 3];
            
               Shoals_Grid.graphics_handle.drawLine((x >>> shift) - size_x, y >>> shift, (x >>> shift) + size_x, y >>> shift);
               Shoals_Grid.graphics_handle.drawLine(x >>> shift, (y >>> shift) - size_y, x >>> shift, (y >>> shift) + size_y);
            
               break;
         }
      }
   
   
      public void travel() {
         x = x + dx;
         y = y + dy;
      
         // applyFriction();
      
         count--;
      
         // size = 1 + (count >> 3);
      
      	//if (count < 0) {
      
      	// }
      /*
         if ((x >> shift) > Shoals_Canvas.gsx) {
            x = Shoals_Canvas.gsx << shift; //x - dx;
            dx = -(int)(dx * 0.9);
         }
      
         if (x < 0) {
            x = 0;
            dx = -(int)(dx * 0.9);
         }
      
         if ((y >> shift) > Shoals_Canvas.gsy) {
            y = Shoals_Canvas.gsy << shift; //x - dx;
            dy = -(int)(dy * 0.9);
         }
      
         if (y < 0) {
            y = 0;
            dy = -(int)(dy * 0.9);
         }
      */
         // absdx = (dx > 0) ? dx : -dx;
         // absdy = (dy > 0) ? dy : -dy;
      
        //  adjustDirection();
      }
   
   /*
      public void applyFriction() {
      
      // cap velocities...
         if ((Shoals_Grid.generation & 7) == 0) {
            if (dx > 0) {
               dx -= friction_strength;
            }
         
            if (dx < 0) {
               dx += friction_strength;
            }
         
            if (dy > 0) {
               dy -= friction_strength;
            }
         
            if (dy < 0) {
               dy += friction_strength;
            }
         }
      }
   	*/
   
   }
