/*
 * PrivateWorld Tyler 1998-1999.
 */

   /*
	import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;
	*/

   public class PrivateWorld extends Object {
      // stuff...
   
      LinkManager link_manager;
      CreatureManager creature_manager;
   
      Link entity_link[];
   
      Entity associated_entity;
   
      Entity[] agent;
   
      int number_of_agents         = 0;
      int max_number_of_agents     = 1;
   
      // static...
      static int xoffset = 0;
      static int yoffset = 0;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
      static int shift = Entity.shift;
      static Entity[] new_array_of_agents;
      static int temp_x, temp_y, temp_radius;
      static Entity temp_agent;
      static Entity temp2_agent;
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static int temp_detection_distance;
      static int temp_detection_distance2;
      static int temp_detection_distanceo2;
      static int temp_detection_distance2o2;
      static int temp_detection_distance_squared;
   
      static boolean collide_with_self; // used in collisions...
   
      static int magnitude;
      static int minimum_magnitude = 0; // 1024;
      static int maximum_magnitude = 1 << 24; // 512; // 1024;
   
      static int agent_counter;
      static int temp_direction;
   
      static int tadx;
      static int tady;
      static int t2adx;
      static int t2ady;
      static int temp_count;
      static int temp_ma;
   
      static int average_dx;
      static int average_dy;
      static int ENTITY_NUMBER_INCREMENT = 256; 
   
      PrivateWorld() {
         init();
         set(null);
      }
   
   
      PrivateWorld(Entity e) {
         init();
         set(e);
      }
   
   
      public void init() {
         max_number_of_agents = 1;
         agent = new Entity[max_number_of_agents];
         link_manager = new LinkManager();
         creature_manager = new CreatureManager();
      }
   
   
      public void set(Entity e) {
         // init();
         associated_entity = e;
         number_of_agents = 0;
      
         link_manager.reset();
         creature_manager.reset();
      }
   
   
      public void reset() {
         set(null);
      }
   
   
      public void initial() {
         set(null);
      }
   
   
      public Entity copy(Entity e) {
         if (number_of_agents >= max_number_of_agents) {
            makeMoreEntities();
         }
      
         if (agent[number_of_agents] == null) {
            temp_agent = new Entity(e);
            agent[number_of_agents++] = temp_agent;
         }
         else
         {
            temp_agent = agent[number_of_agents++];
            temp_agent.set(e);
         }
      
         // number_of_agents++;
      
         return temp_agent;
      }
   
   
      public void bufferedUpdate() {
         if (Shoals.use_links) {
            Link.temp_private_world = this;
            link_manager.scrubTheLinks();
            link_manager.exerciseTheLinks();
         }
      
         if (number_of_agents > 0) {
            scrubTheAgents();
            if (!Shoals.paused) {
               travelTheAgents();
            }
         }
      
         if (Shoals.use_links) {
            link_manager.drawTheLinks();
         
         }
      
         if (number_of_agents > 0) {
            drawTheAgents();
         }
      
         //apply_acceleration();
         if (Shoals.check_collisions) {
            if (!Shoals.paused) {
               collisionCheckNbyN();
            }
         }
      }
   
   
      void unbufferedUpdate() {
         Entity.temp_private_world = this;
         if (Shoals.frame_frequency == 0) {
            if (number_of_agents > 0) {
               for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
               // for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
                  temp_agent = agent[agent_counter]; // this is sometimes null...
               
                  //if (temp_agent == null) {
                     //debug("agent_counter" + agent_counter);
                     //if (Entity.temp_private_world == Shoals.entity_manager) {
                        //debug("SEM");
                     //}
                     //do { } while(true) ;
                  //}
               
                  Shoals_Grid.colourZero();
                  temp_agent.scrub(); // this is sometimes null...
               
                  if (!Shoals.paused) {
                     temp_agent.travel();
                     confine();
                  }
               
                  temp_agent.draw();
               }
            }
         
            if (Shoals.use_links) {
               Link.temp_private_world = this;
               link_manager.linkUpdating();
            }
         
            if (!Shoals.paused) {
               if (Shoals.check_collisions) {
                  collisionCheckNbyN();
               }
            }
         }
         else
         {
            if (number_of_agents > 0) {
               scrubTheAgents();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (number_of_agents > 0) {
                     travelTheAgents();
                  }
               
                  if (Shoals.use_links) {
                     Link.temp_private_world = this;
                     link_manager.linkUpdating();
                  }
               
                  if (Shoals.check_collisions) {
                     collisionCheckNbyN();
                  }
               }
            }
         
            if (number_of_agents > 0) {
               drawTheAgents();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (!Shoals.paused) {
                  if (Shoals.check_collisions) {
                     collisionCheckNbyN();
                  }
               }
            }
         }
      }
   
   
      public void collisionCheckNbyN() {
         for (temp = 0; temp < (number_of_agents - 1); temp++) {
            setUpEMTempAgent();
            for (temp2 = temp + 1; temp2 < (number_of_agents); temp2++) {
               setUpEMTemp2Agent();
               Shoals.entity_manager.collideTheseEntities();
            }
         }
      }
   
   
      public void setUpEMTempAgent() {
         Shoals.entity_manager.temp_agent = agent[temp];
      }
   
   
      public void setUpEMTemp2Agent() {
         Shoals.entity_manager.temp2_agent = agent[temp2];
      }
   
   
      void drawTheAgents() {
         Shoals_Grid.last_colour = -1;
         // for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
         for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            agent[agent_counter].draw();
         }
      }
   
   
      void scrubTheAgents() {
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
         // for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            agent[agent_counter].scrub();
         }
      }
   
   
      void scrub() {
         scrubTheAgents(); // problems...
         // scrubTheLinks();
      }
   
   
      void travelTheAgents() {
         Entity.temp_private_world = this;
         // for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
         for (agent_counter = number_of_agents; --agent_counter >= 0; ) {
            temp_agent = agent[agent_counter];
            temp_agent.travel();
            confine();
         }
      }
   
   
      public void setGlobalSize(int d) {
         // general_size = d;
      
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].setSize((byte)d);
         }
      
         for (temp = 0; temp < Entity.TRIG_TAB_SIZE; temp++) {
            Entity.ship_image_array[temp] = null;
         }
      
      }
   
   
      // wastes memory, but who cares?
      Entity addNewAgent() {
         // debug("NOA:" + number_of_agents);
         if (number_of_agents >= max_number_of_agents) {
            makeMoreEntities();
         }
      
         if (agent[number_of_agents] == null) {
            temp_agent = new Entity(0, 0, rnd.nextInt());
            agent[number_of_agents++] = temp_agent;
         }
         else
         {
            temp_agent = agent[number_of_agents++];
            temp_agent.set(0, 0, rnd.nextInt());
         }
      
      /*
         if (number_of_agents > 1) {
            temp = rnd.nextInt(number_of_agents - 1); // ?
            temp_x = agent[temp].x + rnd.nextInt(256);
            temp_y = agent[temp].y + rnd.nextInt(256);
         
            new_array_of_agents[number_of_agents - 1] = new Entity(temp_x, temp_y, rnd.nextInt());
            new_array_of_agents[number_of_agents - 1].colour = agent[temp].colour;
            new_array_of_agents[number_of_agents - 1].setInitialSize((byte)agent[temp].diameter,(byte)agent[temp].diameter);
         }
         else
         {
            temp_x = rnd.nextInt(Shoals_Canvas.gsx) << shift;
            temp_y = rnd.nextInt(Shoals_Canvas.gsy) << shift;
         
            new_array_of_agents[number_of_agents - 1] = new Entity(temp_x, temp_y, rnd.nextInt());
         }
      	*/
      
         //agent = new_array_of_agents;
      
         // number_of_agents++;
      
         return temp_agent;
      }
   
   
      Entity addNewAgent(int x, int y, char colour, byte diameter, byte lm, int status) {
         // debug("X - NOA:" + number_of_agents);
         if (number_of_agents >= max_number_of_agents) {
            makeMoreEntities();
         }
      
         if (agent[number_of_agents] == null) {
            temp_agent = new Entity(x, y, rnd.nextInt());
            agent[number_of_agents++] = temp_agent;
         }
         else
         {
            temp_agent = agent[number_of_agents++];
            temp_agent.set(x, y, rnd.nextInt());
         }
      
         temp_agent.colour = (char)colour;
         temp_agent.status = status;
         temp_agent.setInitialSize(diameter, diameter);
         temp_agent.setMass(lm);
      
         return temp_agent;
      }
   
   
      Entity addNewAgent(Entity e) {
         if (number_of_agents >= max_number_of_agents) {
            makeMoreEntities();
         }
      
         if (agent[number_of_agents] == null) {
            temp_agent = new Entity(e);
            agent[number_of_agents++] = temp_agent;
         }
         else
         {
            temp_agent = agent[number_of_agents++];
            temp_agent.set(e);
         }
      
         return temp_agent;
      }
   
   
   /*
   // DANGER...
      Entity addNewAgent(Entity e) {
         if (number_of_agents >= max_number_of_agents) {
            makeMoreEntities();
         }
      
         agent[number_of_agents] = e;
      
         return agent[number_of_agents++];
      }
   */
   
   
      void makeMoreEntities() {
         new_array_of_agents = new Entity[max_number_of_agents + ENTITY_NUMBER_INCREMENT];
      
         for (temp = max_number_of_agents; --temp >= 0; ) {
            new_array_of_agents[temp] = agent[temp];
         }
      
         agent = new_array_of_agents;
      
         max_number_of_agents += ENTITY_NUMBER_INCREMENT;
      }
   
   
      void killAgent() {
         if (number_of_agents > 0) {
            link_manager.killAllLinks(agent[number_of_agents - 1]);
            number_of_agents--;
         }
      }
   
   
      boolean killThisEntity(Entity e) {
         for (temp = number_of_agents; --temp >= 0; ) {
            if (agent[temp] == e) {
               killNumberedAgent(temp);
               return true;
            }
         }
      
         debug("Target entity not found!");
      
         return false;
      }
   
   
      void killNumberedAgent(int n) {
         Shoals_Grid.colourZero();
         agent[n].scrub();
         link_manager.killAllLinks(agent[n]);
         temp_agent = agent[n];
         agent[n] = agent[number_of_agents - 1];
         agent[--number_of_agents] = temp_agent;
      }
   
   
      // returns distance in pixels...
      int distanceBetween(Entity e1, Entity e2) {
         temp2 = (e1.x - e2.x) >> shift;
         temp3 = (e1.y - e2.y) >> shift;
         temp_radius = temp2 * temp2 + temp3 * temp3;
      
         return SquareRoot.sqrt(temp_radius);
      }
   
   
      int getAgentNumber(Entity e) {
         for (temp = number_of_agents; --temp >= 0; ) {
            if (agent[temp] == e) {
               return temp;
            }
         }
      
         debug("Entity not found...");
      
         return -1;
      }
   
   
      Entity getSelectedEntity() {
         for (temp = number_of_agents; --temp >= 0; ) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               return agent[temp];
            }
         }
      
         return null;
      }
   
   
      void deselectAll() {
         for (temp = number_of_agents; --temp >= 0; ) {
            if ((agent[temp].status & Entity.SELECTED) != 0) {
               agent[temp].scrub();
               agent[temp].status &= (-1 ^ Entity.SELECTED);
            }
         }
      }
   
   
      void deleteSelected() {
         for (temp2 = number_of_agents; --temp2 >= 0; ) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               Shoals.killAllLinks(temp_agent);
               killThisEntity(temp_agent);
               temp2--;
            }
         }
      }
   
   
      void setColourOfSelected(char c) {
         for (temp2 = number_of_agents; --temp2 >= 0; ) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.colour = c;
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      void setSizeOfSelected(int s) {
         for (temp2 = number_of_agents; --temp2 >= 0; ) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.setSize((byte)s);
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      void affectStatusBits(int and, int xor) {
         for (temp = number_of_agents; --temp >= 0; ) {
            temp_agent = agent[temp];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.status = (temp_agent.status & and) ^ xor;
            }
         }
      }
   
   
      void moveSelection(int _dx, int _dy) {
         for (temp2 = number_of_agents; --temp2 >= 0; ) {
            temp_agent = agent[temp2];
            if ((temp_agent.status & Entity.SELECTED) != 0) {
               temp_agent.x += _dx;
               temp_agent.y += _dy;
               temp_agent.dx = 0;
               temp_agent.dy = 0;
            
               temp_agent.boundaryCheck();
            
               // make sure bins are updated...
               temp_agent.findNewBin();
            }
         }
      }
   
   
      void centre() {
         for (temp = number_of_agents; --temp >= 0; ) {
            temp_agent = agent[temp];
            temp_agent.x = associated_entity.x;
            temp_agent.y = associated_entity.y;
            //temp_agent.z = associated_entity.z;
            temp_agent.dx = 0;
            temp_agent.dy = 0;
            //temp_agent.dz = 0;
         }
      }
      
      
      void confine() {
      //{
         // temp_agent = temp_agent.radius << Entity.shift;
         // collideTheseEntities();
      
         // applyDamping();
      
      	/*
      	temp = temp_agent.radius << Entity.shift;
         temp2= associated_entity.radius << Entity.shift;
         if ((temp_agent.x - temp) < (associated_entity.x - temp2)) {
            temp_agent.x = associated_entity.x - temp2 + temp;
            temp_agent.dx = -temp_agent.dx;
            debug("AER: " + temp2 + " R:" + temp);
         }
      
         if ((temp_agent.x + temp) > (associated_entity.x + temp2)) {
            temp_agent.x = associated_entity.x + temp2 - temp;
            temp_agent.dx = -temp_agent.dx;
         }
      
         if ((temp_agent.y - temp) < (associated_entity.y - temp2)) {
            temp_agent.y = associated_entity.y - temp2 + temp;
            temp_agent.dy = -temp_agent.dy;
         }
      
         if ((temp_agent.y + temp) > (associated_entity.y + temp2)) {
            temp_agent.y = associated_entity.y + temp2 - temp;
            temp_agent.dy = -temp_agent.dy;
         }
      */
      //}
      
      
      // temp_agent,
      // temp2_agent
      
      //public void collideTheseEntities() {
      
         temp_detection_distance = (int)associated_entity.detection_radius - (int)temp_agent.detection_radius; //t this outside the loop?
         temp_detection_distance2 = temp_detection_distance << shift;
         temp_detection_distance2o2 = temp_detection_distance2 >> 1;
      
         temp3 = temp_agent.x - associated_entity.x;
         temp5 = (temp3 < 0) ? -temp3 : temp3; // hmmm...
         temp4 = temp_agent.y - associated_entity.y;
         temp6 = (temp4 < 0) ? -temp4 : temp4;
         if ((temp6 > temp_detection_distance2o2) || (temp5 > temp_detection_distance2o2)) {
              // probable collision...
              // inner diamond check...
            if ((((temp_detection_distance2)) - temp5) < temp6) {
                  // make smaller to prevent overflow...
               tadx = (temp5 >> shift);
               tady = (temp6 >> shift);
               temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
               // temp_detection_distance = temp_detection_distance >> shift;
               temp_detection_distance_squared = temp_detection_distance * temp_detection_distance; // temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
               if (temp_radius >= temp_detection_distance_squared) {
               // collision 
                  collide_with_self = ((temp_agent.creature == associated_entity.creature) && (temp_agent.creature != null));
               // sqrt - really? :-(
                  temp_radius = SquareRoot.sqrt(1 + temp_radius);
               
               // find unit vector along collision path...
                  temp_x = (temp3) / temp_radius; // unit vector * 65536
                  temp_y = (temp4) / temp_radius;
               
                // compute the relative velocities...
                  tadx = temp_agent.dx - associated_entity.dx;
                  tady = temp_agent.dy - associated_entity.dy;
               
                  // dot product...
                  magnitude = (((tadx * temp_x) + (tady * temp_y)) >> (shift - 1));
               
                  // debug("magnitude " + magnitude);
                  if (magnitude > 0) {
                     temp_count = ((temp_radius - temp_detection_distance) << 8) + minimum_magnitude;
                  
                     if (temp_count > maximum_magnitude) {
                        temp_count = maximum_magnitude;
                     }
                  
                     if (magnitude < temp_count) {
                        magnitude = temp_count;
                     }
                  
                     // crude hack - since impulse calculations don't seem to be running yet...
                     temp_x = -temp_x * magnitude;
                     temp_y = -temp_y * magnitude;
                  
                     temp_ma = (temp_agent.log_mass - associated_entity.log_mass);
                  
                     if (temp_ma < 0) {
                        tadx = temp_x >> -temp_ma;
                        tady = temp_y >> -temp_ma;
                     
                        temp_agent.dx += tadx >> 9;
                        temp_agent.dy += tady >> 9;
                        associated_entity.dx -= ((temp_x << 1) - tadx) >> 9;
                        associated_entity.dy -= ((temp_y << 1) - tady) >> 9;
                     }
                     else
                     {
                        tadx = temp_x >> temp_ma;
                        tady = temp_y >> temp_ma;
                     
                        temp_agent.dx += ((temp_x << 1) - tadx) >> 9;
                        temp_agent.dy += ((temp_y << 1) - tady) >> 9;
                        associated_entity.dx -= tadx >> 9;
                        associated_entity.dy -= tady >> 9;
                     }
                  
                     applyDamping();
                     applyDamping();
                  }
               }
            }
         }
      }
   
   
   
      void applyDamping() {
         // internal damping...
         average_dx = temp_agent.dx + associated_entity.dx + 8;
         average_dy = temp_agent.dy + associated_entity.dy + 8;
      
         temp_agent.dx = ((temp_agent.dx * 14) + average_dx) >> 4;
         temp_agent.dy = ((temp_agent.dy * 14) + average_dy) >> 4;
      
         associated_entity.dx = ((associated_entity.dx * 14) + average_dx) >> 4;
         associated_entity.dy = ((associated_entity.dy * 14) + average_dy) >> 4;
      }
   
   
      boolean contains(Entity e) {
         for (temp = number_of_agents; --temp >= 0; ) {
            if (agent[temp] == e) 
               return true;
         }
      
         return false;
      }
   
   
   
   // returns number within this creature...
      final int getEntityNumber(Entity e) {
         for (temp = number_of_agents; --temp >= 0; ) {
            if (agent[temp] == e) {
               return temp;
            }
         }
      
         return -1;
      }
   
   
      static void debug(String o) {
         System.out.println(o);
      }
   
   }
